diff --git a/sys/bus/u4b/audio/uaudio.c b/sys/bus/u4b/audio/uaudio.c
index 039661d..c7bb431 100644
--- a/sys/bus/u4b/audio/uaudio.c
+++ b/sys/bus/u4b/audio/uaudio.c
@@ -2631,125 +4188,391 @@ uaudio_mixer_feature_name(const struct uaudio_terminal_node *iot,
 		uat++;
 	}
 
-	DPRINTF("terminal_type=%s (0x%04x) -> %d\n",
-	    uaudio_mixer_get_terminal_name(terminal_type),
+	DPRINTF("terminal_type=0x%04x -> %d\n",
+	    terminal_type, uat->feature);
+
+	return (uat->feature);
+}
+
+static uint16_t
+uaudio20_mixer_feature_name(const struct uaudio_terminal_node *iot,
+    struct uaudio_mixer_node *mix)
+{
+	const struct uaudio_tt_to_feature *uat;
+	uint16_t terminal_type = uaudio20_mixer_determine_class(iot, mix);
+
+	if ((mix->class == UAC_RECORD) && (terminal_type == 0))
+		return (SOUND_MIXER_IMIX);
+	
+	for (uat = uaudio_tt_to_feature; uat->terminal_type != 0; uat++) {
+		if (uat->terminal_type == terminal_type)
+			break;
+	}
+
+	DPRINTF("terminal_type=0x%04x -> %d\n",
 	    terminal_type, uat->feature);
 
 	return (uat->feature);
 }
 
 static const struct uaudio_terminal_node *
-uaudio_mixer_get_input(const struct uaudio_terminal_node *iot, uint8_t index)
+uaudio_mixer_get_input(const struct uaudio_terminal_node *iot, uint8_t i)
+{
+	struct uaudio_terminal_node *root = iot->root;
+	uint8_t n;
+
+	n = iot->usr.id_max;
+	do {
+		if (iot->usr.bit_input[n / 8] & (1 << (n % 8))) {
+			if (!i--)
+				return (root + n);
+		}
+	} while (n--);
+
+	return (NULL);
+}
+
+static const struct uaudio_terminal_node *
+uaudio_mixer_get_output(const struct uaudio_terminal_node *iot, uint8_t i)
 {
 	struct uaudio_terminal_node *root = iot->root;
 	uint8_t n;
 
-	n = iot->usr.id_max;
-	do {
-		if (iot->usr.bit_input[n / 8] & (1 << (n % 8))) {
-			if (!index--) {
-				return (root + n);
+	n = iot->usr.id_max;
+	do {
+		if (iot->usr.bit_output[n / 8] & (1 << (n % 8))) {
+			if (!i--)
+				return (root + n);
+		}
+	} while (n--);
+
+	return (NULL);
+}
+
+static void
+uaudio_mixer_find_inputs_sub(struct uaudio_terminal_node *root,
+    const uint8_t *p_id, uint8_t n_id,
+    struct uaudio_search_result *info)
+{
+	struct uaudio_terminal_node *iot;
+	uint8_t n;
+	uint8_t i;
+	uint8_t is_last;
+
+top:
+	for (n = 0; n < n_id; n++) {
+
+		i = p_id[n];
+
+		if (info->recurse_level == UAUDIO_RECURSE_LIMIT) {
+			DPRINTF("avoided going into a circle at id=%d!\n", i);
+			return;
+		}
+
+		info->recurse_level++;
+
+		iot = (root + i);
+
+		if (iot->u.desc == NULL)
+			continue;
+
+		is_last = ((n + 1) == n_id);
+
+		switch (iot->u.desc->bDescriptorSubtype) {
+		case UDESCSUB_AC_INPUT:
+			info->bit_input[i / 8] |= (1 << (i % 8));
+			break;
+
+		case UDESCSUB_AC_FEATURE:
+			if (is_last) {
+				p_id = &iot->u.fu_v1->bSourceId;
+				n_id = 1;
+				goto top;
+			}
+			uaudio_mixer_find_inputs_sub(
+			    root, &iot->u.fu_v1->bSourceId, 1, info);
+			break;
+
+		case UDESCSUB_AC_OUTPUT:
+			if (is_last) {
+				p_id = &iot->u.ot_v1->bSourceId;
+				n_id = 1;
+				goto top;
+			}
+			uaudio_mixer_find_inputs_sub(
+			    root, &iot->u.ot_v1->bSourceId, 1, info);
+			break;
+
+		case UDESCSUB_AC_MIXER:
+			if (is_last) {
+				p_id = iot->u.mu_v1->baSourceId;
+				n_id = iot->u.mu_v1->bNrInPins;
+				goto top;
+			}
+			uaudio_mixer_find_inputs_sub(
+			    root, iot->u.mu_v1->baSourceId,
+			    iot->u.mu_v1->bNrInPins, info);
+			break;
+
+		case UDESCSUB_AC_SELECTOR:
+			if (is_last) {
+				p_id = iot->u.su_v1->baSourceId;
+				n_id = iot->u.su_v1->bNrInPins;
+				goto top;
+			}
+			uaudio_mixer_find_inputs_sub(
+			    root, iot->u.su_v1->baSourceId,
+			    iot->u.su_v1->bNrInPins, info);
+			break;
+
+		case UDESCSUB_AC_PROCESSING:
+			if (is_last) {
+				p_id = iot->u.pu_v1->baSourceId;
+				n_id = iot->u.pu_v1->bNrInPins;
+				goto top;
+			}
+			uaudio_mixer_find_inputs_sub(
+			    root, iot->u.pu_v1->baSourceId,
+			    iot->u.pu_v1->bNrInPins, info);
+			break;
+
+		case UDESCSUB_AC_EXTENSION:
+			if (is_last) {
+				p_id = iot->u.eu_v1->baSourceId;
+				n_id = iot->u.eu_v1->bNrInPins;
+				goto top;
+			}
+			uaudio_mixer_find_inputs_sub(
+			    root, iot->u.eu_v1->baSourceId,
+			    iot->u.eu_v1->bNrInPins, info);
+			break;
+
+		default:
+			break;
+		}
+	}
+}
+
+static void
+uaudio20_mixer_find_inputs_sub(struct uaudio_terminal_node *root,
+    const uint8_t *p_id, uint8_t n_id,
+    struct uaudio_search_result *info)
+{
+	struct uaudio_terminal_node *iot;
+	uint8_t n;
+	uint8_t i;
+	uint8_t is_last;
+
+top:
+	for (n = 0; n < n_id; n++) {
+
+		i = p_id[n];
+
+		if (info->recurse_level == UAUDIO_RECURSE_LIMIT) {
+			DPRINTF("avoided going into a circle at id=%d!\n", i);
+			return;
+		}
+
+		info->recurse_level++;
+
+		iot = (root + i);
+
+		if (iot->u.desc == NULL)
+			continue;
+
+		is_last = ((n + 1) == n_id);
+
+		switch (iot->u.desc->bDescriptorSubtype) {
+		case UDESCSUB_AC_INPUT:
+			info->bit_input[i / 8] |= (1 << (i % 8));
+			break;
+
+		case UDESCSUB_AC_OUTPUT:
+			if (is_last) {
+				p_id = &iot->u.ot_v2->bSourceId;
+				n_id = 1;
+				goto top;
+			}
+			uaudio20_mixer_find_inputs_sub(
+			    root, &iot->u.ot_v2->bSourceId, 1, info);
+			break;
+
+		case UDESCSUB_AC_MIXER:
+			if (is_last) {
+				p_id = iot->u.mu_v2->baSourceId;
+				n_id = iot->u.mu_v2->bNrInPins;
+				goto top;
+			}
+			uaudio20_mixer_find_inputs_sub(
+			    root, iot->u.mu_v2->baSourceId,
+			    iot->u.mu_v2->bNrInPins, info);
+			break;
+
+		case UDESCSUB_AC_SELECTOR:
+			if (is_last) {
+				p_id = iot->u.su_v2->baSourceId;
+				n_id = iot->u.su_v2->bNrInPins;
+				goto top;
+			}
+			uaudio20_mixer_find_inputs_sub(
+			    root, iot->u.su_v2->baSourceId,
+			    iot->u.su_v2->bNrInPins, info);
+			break;
+
+		case UDESCSUB_AC_SAMPLE_RT:
+			if (is_last) {
+				p_id = &iot->u.ru_v2->bSourceId;
+				n_id = 1;
+				goto top;
+			}
+			uaudio20_mixer_find_inputs_sub(
+			    root, &iot->u.ru_v2->bSourceId,
+			    1, info);
+			break;
+
+		case UDESCSUB_AC_EFFECT:
+			if (is_last) {
+				p_id = &iot->u.ef_v2->bSourceId;
+				n_id = 1;
+				goto top;
 			}
-		}
-	} while (n--);
+			uaudio20_mixer_find_inputs_sub(
+			    root, &iot->u.ef_v2->bSourceId,
+			    1, info);
+			break;
 
-	return (NULL);
-}
+		case UDESCSUB_AC_FEATURE:
+			if (is_last) {
+				p_id = &iot->u.fu_v2->bSourceId;
+				n_id = 1;
+				goto top;
+			}
+			uaudio20_mixer_find_inputs_sub(
+			    root, &iot->u.fu_v2->bSourceId, 1, info);
+			break;
 
-static const struct uaudio_terminal_node *
-uaudio_mixer_get_output(const struct uaudio_terminal_node *iot, uint8_t index)
-{
-	struct uaudio_terminal_node *root = iot->root;
-	uint8_t n;
+		case UDESCSUB_AC_PROCESSING_V2:
+			if (is_last) {
+				p_id = iot->u.pu_v2->baSourceId;
+				n_id = iot->u.pu_v2->bNrInPins;
+				goto top;
+			}
+			uaudio20_mixer_find_inputs_sub(
+			    root, iot->u.pu_v2->baSourceId,
+			    iot->u.pu_v2->bNrInPins, info);
+			break;
 
-	n = iot->usr.id_max;
-	do {
-		if (iot->usr.bit_output[n / 8] & (1 << (n % 8))) {
-			if (!index--) {
-				return (root + n);
+		case UDESCSUB_AC_EXTENSION_V2:
+			if (is_last) {
+				p_id = iot->u.eu_v2->baSourceId;
+				n_id = iot->u.eu_v2->bNrInPins;
+				goto top;
 			}
+			uaudio20_mixer_find_inputs_sub(
+			    root, iot->u.eu_v2->baSourceId,
+			    iot->u.eu_v2->bNrInPins, info);
+			break;
+		default:
+			break;
 		}
-	} while (n--);
-
-	return (NULL);
+	}
 }
 
 static void
-uaudio_mixer_find_inputs_sub(struct uaudio_terminal_node *root,
+uaudio20_mixer_find_clocks_sub(struct uaudio_terminal_node *root,
     const uint8_t *p_id, uint8_t n_id,
     struct uaudio_search_result *info)
 {
 	struct uaudio_terminal_node *iot;
 	uint8_t n;
 	uint8_t i;
+	uint8_t is_last;
+	uint8_t id;
 
-	if (info->recurse_level >= UAUDIO_RECURSE_LIMIT) {
-		return;
-	}
-	info->recurse_level++;
-
+top:
 	for (n = 0; n < n_id; n++) {
 
 		i = p_id[n];
 
-		if (info->bit_visited[i / 8] & (1 << (i % 8))) {
-			/* don't go into a circle */
+		if (info->recurse_level == UAUDIO_RECURSE_LIMIT) {
 			DPRINTF("avoided going into a circle at id=%d!\n", i);
-			continue;
-		} else {
-			info->bit_visited[i / 8] |= (1 << (i % 8));
+			return;
 		}
 
+		info->recurse_level++;
+
 		iot = (root + i);
 
-		if (iot->u.desc == NULL) {
+		if (iot->u.desc == NULL)
 			continue;
-		}
+
+		is_last = ((n + 1) == n_id);
+
 		switch (iot->u.desc->bDescriptorSubtype) {
 		case UDESCSUB_AC_INPUT:
-			info->bit_input[i / 8] |= (1 << (i % 8));
-			break;
-
-		case UDESCSUB_AC_FEATURE:
-			uaudio_mixer_find_inputs_sub
-			    (root, &iot->u.fu->bSourceId, 1, info);
+			info->is_input = 1;
+			if (is_last) {
+				p_id = &iot->u.it_v2->bCSourceId;
+				n_id = 1;
+				goto top;
+			}
+			uaudio20_mixer_find_clocks_sub(root,
+			    &iot->u.it_v2->bCSourceId, 1, info);
 			break;
 
 		case UDESCSUB_AC_OUTPUT:
-			uaudio_mixer_find_inputs_sub
-			    (root, &iot->u.ot->bSourceId, 1, info);
+			info->is_input = 0;
+			if (is_last) {
+				p_id = &iot->u.ot_v2->bCSourceId;
+				n_id = 1;
+				goto top;
+			}
+			uaudio20_mixer_find_clocks_sub(root,
+			    &iot->u.ot_v2->bCSourceId, 1, info);
 			break;
 
-		case UDESCSUB_AC_MIXER:
-			uaudio_mixer_find_inputs_sub
-			    (root, iot->u.mu->baSourceId,
-			    iot->u.mu->bNrInPins, info);
+		case UDESCSUB_AC_CLOCK_SEL:
+			if (is_last) {
+				p_id = iot->u.csel_v2->baCSourceId;
+				n_id = iot->u.csel_v2->bNrInPins;
+				goto top;
+			}
+			uaudio20_mixer_find_clocks_sub(root,
+			    iot->u.csel_v2->baCSourceId,
+			    iot->u.csel_v2->bNrInPins, info);
 			break;
 
-		case UDESCSUB_AC_SELECTOR:
-			uaudio_mixer_find_inputs_sub
-			    (root, iot->u.su->baSourceId,
-			    iot->u.su->bNrInPins, info);
+		case UDESCSUB_AC_CLOCK_MUL:
+			if (is_last) {
+				p_id = &iot->u.cmul_v2->bCSourceId;
+				n_id = 1;
+				goto top;
+			}
+			uaudio20_mixer_find_clocks_sub(root,
+			    &iot->u.cmul_v2->bCSourceId,
+			    1, info);
 			break;
 
-		case UDESCSUB_AC_PROCESSING:
-			uaudio_mixer_find_inputs_sub
-			    (root, iot->u.pu->baSourceId,
-			    iot->u.pu->bNrInPins, info);
-			break;
+		case UDESCSUB_AC_CLOCK_SRC:
 
-		case UDESCSUB_AC_EXTENSION:
-			uaudio_mixer_find_inputs_sub
-			    (root, iot->u.eu->baSourceId,
-			    iot->u.eu->bNrInPins, info);
+			id = iot->u.csrc_v2->bClockId;
+
+			switch (info->is_input) {
+			case 0:
+				info->bit_output[id / 8] |= (1 << (id % 8));
+				break;
+			case 1:
+				info->bit_input[id / 8] |= (1 << (id % 8));
+				break;
+			default:
+				break;
+			}
 			break;
 
-		case UDESCSUB_AC_HEADER:
 		default:
 			break;
 		}
 	}
-	info->recurse_level--;
 }
 
 static void
@@ -2778,8 +4601,8 @@ uaudio_mixer_find_outputs_sub(struct uaudio_terminal_node *root, uint8_t id,
 }
 
 static void
-uaudio_mixer_fill_info(struct uaudio_softc *sc, struct usb_device *udev,
-    void *desc)
+uaudio_mixer_fill_info(struct uaudio_softc *sc,
+    struct usb_device *udev, void *desc)
 {
 	const struct usb_audio_control_descriptor *acdp;
 	struct usb_config_descriptor *cd = usbd_get_config_descriptor(udev);
@@ -2813,15 +4636,6 @@ uaudio_mixer_fill_info(struct uaudio_softc *sc, struct usb_device *udev,
 	DPRINTFN(3, "found AC header, vers=%03x, len=%d\n",
 	    sc->sc_audio_rev, wTotalLen);
 
-	if (sc->sc_audio_rev != UAUDIO_VERSION) {
-
-		if (sc->sc_uq_bad_adc) {
-
-		} else {
-			DPRINTF("invalid audio version\n");
-			goto done;
-		}
-	}
 	iot = kmalloc(sizeof(struct uaudio_terminal_node) * 256, M_TEMP,
 	    M_WAITOK | M_ZERO);
 
@@ -2835,13 +4649,17 @@ uaudio_mixer_fill_info(struct uaudio_softc *sc, struct usb_device *udev,
 			wTotalLen -= dp->bLength;
 		}
 
-		au = uaudio_mixer_verify_desc(dp, 0);
+		if (sc->sc_audio_rev >= UAUDIO_VERSION_30)
+			au = NULL;
+		else if (sc->sc_audio_rev >= UAUDIO_VERSION_20)
+			au = uaudio20_mixer_verify_desc(dp, 0);
+		else
+			au = uaudio_mixer_verify_desc(dp, 0);
 
 		if (au) {
 			iot[au->bUnitId].u.desc = (const void *)au;
-			if (au->bUnitId > ID_max) {
+			if (au->bUnitId > ID_max)
 				ID_max = au->bUnitId;
-			}
 		}
 	}
 
@@ -2853,7 +4671,21 @@ uaudio_mixer_fill_info(struct uaudio_softc *sc, struct usb_device *udev,
 	 */
 	i = ID_max;
 	do {
-		uaudio_mixer_find_inputs_sub(iot, &i, 1, &((iot + i)->usr));
+		if (sc->sc_audio_rev >= UAUDIO_VERSION_30) {
+			/* FALLTHROUGH */
+		} else if (sc->sc_audio_rev >= UAUDIO_VERSION_20) {
+			uaudio20_mixer_find_inputs_sub(iot,
+			    &i, 1, &((iot + i)->usr));
+
+			sc->sc_mixer_clocks.is_input = 255;
+			sc->sc_mixer_clocks.recurse_level = 0;
+
+			uaudio20_mixer_find_clocks_sub(iot,
+			    &i, 1, &sc->sc_mixer_clocks);
+		} else {
+			uaudio_mixer_find_inputs_sub(iot,
+			    &i, 1, &((iot + i)->usr));
+		}
 	} while (i--);
 
 	/*
@@ -2862,7 +4694,8 @@ uaudio_mixer_fill_info(struct uaudio_softc *sc, struct usb_device *udev,
 	 */
 	i = ID_max;
 	do {
-		uaudio_mixer_find_outputs_sub(iot, i, ID_max, &((iot + i)->usr));
+		uaudio_mixer_find_outputs_sub(iot,
+		    i, ID_max, &((iot + i)->usr));
 	} while (i--);
 
 	/* set "id_max" and "root" */
@@ -2873,106 +4706,59 @@ uaudio_mixer_fill_info(struct uaudio_softc *sc, struct usb_device *udev,
 		(iot + i)->root = iot;
 	} while (i--);
 
-#ifdef USB_DEBUG
+	/*
+	 * Scan the config to create a linked list of "mixer" nodes:
+	 */
+
 	i = ID_max;
 	do {
-		uint8_t j;
+		dp = iot[i].u.desc;
 
-		if (iot[i].u.desc == NULL) {
+		if (dp == NULL)
 			continue;
-		}
-		DPRINTF("id %d:\n", i);
-
-		switch (iot[i].u.desc->bDescriptorSubtype) {
-		case UDESCSUB_AC_INPUT:
-			DPRINTF(" - AC_INPUT type=%s\n",
-			    uaudio_mixer_get_terminal_name
-			    (UGETW(iot[i].u.it->wTerminalType)));
-			uaudio_mixer_dump_cluster(i, iot);
-			break;
-
-		case UDESCSUB_AC_OUTPUT:
-			DPRINTF(" - AC_OUTPUT type=%s "
-			    "src=%d\n", uaudio_mixer_get_terminal_name
-			    (UGETW(iot[i].u.ot->wTerminalType)),
-			    iot[i].u.ot->bSourceId);
-			break;
-
-		case UDESCSUB_AC_MIXER:
-			DPRINTF(" - AC_MIXER src:\n");
-			for (j = 0; j < iot[i].u.mu->bNrInPins; j++) {
-				DPRINTF("   - %d\n", iot[i].u.mu->baSourceId[j]);
-			}
-			uaudio_mixer_dump_cluster(i, iot);
-			break;
-
-		case UDESCSUB_AC_SELECTOR:
-			DPRINTF(" - AC_SELECTOR src:\n");
-			for (j = 0; j < iot[i].u.su->bNrInPins; j++) {
-				DPRINTF("   - %d\n", iot[i].u.su->baSourceId[j]);
-			}
-			break;
 
-		case UDESCSUB_AC_FEATURE:
-			DPRINTF(" - AC_FEATURE src=%d\n", iot[i].u.fu->bSourceId);
-			break;
+		DPRINTFN(11, "id=%d subtype=%d\n",
+		    i, dp->bDescriptorSubtype);
 
-		case UDESCSUB_AC_PROCESSING:
-			DPRINTF(" - AC_PROCESSING src:\n");
-			for (j = 0; j < iot[i].u.pu->bNrInPins; j++) {
-				DPRINTF("   - %d\n", iot[i].u.pu->baSourceId[j]);
-			}
-			uaudio_mixer_dump_cluster(i, iot);
-			break;
+		if (sc->sc_audio_rev >= UAUDIO_VERSION_30) {
+			continue;
+		} else if (sc->sc_audio_rev >= UAUDIO_VERSION_20) {
 
-		case UDESCSUB_AC_EXTENSION:
-			DPRINTF(" - AC_EXTENSION src:\n");
-			for (j = 0; j < iot[i].u.eu->bNrInPins; j++) {
-				DPRINTF("%d ", iot[i].u.eu->baSourceId[j]);
-			}
-			uaudio_mixer_dump_cluster(i, iot);
-			break;
+			switch (dp->bDescriptorSubtype) {
+			case UDESCSUB_AC_HEADER:
+				DPRINTF("unexpected AC header\n");
+				break;
 
-		default:
-			DPRINTF("unknown audio control (subtype=%d)\n",
-			    iot[i].u.desc->bDescriptorSubtype);
-		}
+			case UDESCSUB_AC_INPUT:
+			case UDESCSUB_AC_OUTPUT:
+			case UDESCSUB_AC_PROCESSING_V2:
+			case UDESCSUB_AC_EXTENSION_V2:
+			case UDESCSUB_AC_EFFECT:
+			case UDESCSUB_AC_CLOCK_SRC:
+			case UDESCSUB_AC_CLOCK_SEL:
+			case UDESCSUB_AC_CLOCK_MUL:
+			case UDESCSUB_AC_SAMPLE_RT:
+				break;
 
-		DPRINTF("Inputs to this ID are:\n");
+			case UDESCSUB_AC_MIXER:
+				uaudio20_mixer_add_mixer(sc, iot, i);
+				break;
 
-		j = ID_max;
-		do {
-			if (iot[i].usr.bit_input[j / 8] & (1 << (j % 8))) {
-				DPRINTF("  -- ID=%d\n", j);
-			}
-		} while (j--);
+			case UDESCSUB_AC_SELECTOR:
+				uaudio20_mixer_add_selector(sc, iot, i);
+				break;
 
-		DPRINTF("Outputs from this ID are:\n");
+			case UDESCSUB_AC_FEATURE:
+				uaudio20_mixer_add_feature(sc, iot, i);
+				break;
 
-		j = ID_max;
-		do {
-			if (iot[i].usr.bit_output[j / 8] & (1 << (j % 8))) {
-				DPRINTF("  -- ID=%d\n", j);
+			default:
+				DPRINTF("bad AC desc subtype=0x%02x\n",
+				    dp->bDescriptorSubtype);
+				break;
 			}
-		} while (j--);
-
-	} while (i--);
-#endif
-
-	/*
-	 * scan the config to create a linked
-	 * list of "mixer" nodes:
-	 */
-
-	i = ID_max;
-	do {
-		dp = iot[i].u.desc;
-
-		if (dp == NULL) {
 			continue;
 		}
-		DPRINTFN(11, "id=%d subtype=%d\n",
-		    i, dp->bDescriptorSubtype);
 
 		switch (dp->bDescriptorSubtype) {
 		case UDESCSUB_AC_HEADER:
@@ -2980,11 +4766,7 @@ uaudio_mixer_fill_info(struct uaudio_softc *sc, struct usb_device *udev,
 			break;
 
 		case UDESCSUB_AC_INPUT:
-			uaudio_mixer_add_input(sc, iot, i);
-			break;
-
 		case UDESCSUB_AC_OUTPUT:
-			uaudio_mixer_add_output(sc, iot, i);
 			break;
 
 		case UDESCSUB_AC_MIXER:
@@ -3016,42 +4798,76 @@ uaudio_mixer_fill_info(struct uaudio_softc *sc, struct usb_device *udev,
 	} while (i--);
 
 done:
-	if (iot) {
-		kfree(iot, M_TEMP);
-	}
+	kfree(iot, M_TEMP);
 }
 
-static uint16_t
-uaudio_mixer_get(struct usb_device *udev, uint8_t what,
-    struct uaudio_mixer_node *mc)
+static int
+uaudio_mixer_get(struct usb_device *udev, uint16_t audio_rev,
+    uint8_t what, struct uaudio_mixer_node *mc)
 {
 	struct usb_device_request req;
-	uint16_t val;
-	uint16_t len = MIX_SIZE(mc->type);
-	uint8_t data[4];
+	int val;
+	uint8_t data[2 + (2 * 3)];
 	usb_error_t err;
 
-	if (mc->wValue[0] == -1) {
+	if (mc->wValue[0] == -1)
+		return (0);
+
+	if (audio_rev >= UAUDIO_VERSION_30)
 		return (0);
+	else if (audio_rev >= UAUDIO_VERSION_20) {
+		if (what == GET_CUR) {
+			req.bRequest = UA20_CS_CUR;
+			USETW(req.wLength, 2);
+		} else {
+			req.bRequest = UA20_CS_RANGE;
+			USETW(req.wLength, 8);
+		}
+	} else {
+		uint16_t len = MIX_SIZE(mc->type);
+
+		req.bRequest = what;
+		USETW(req.wLength, len);
 	}
+
 	req.bmRequestType = UT_READ_CLASS_INTERFACE;
-	req.bRequest = what;
 	USETW(req.wValue, mc->wValue[0]);
 	USETW(req.wIndex, mc->wIndex);
-	USETW(req.wLength, len);
+
+	memset(data, 0, sizeof(data));
 
 	err = usbd_do_request(udev, NULL, &req, data);
 	if (err) {
 		DPRINTF("err=%s\n", usbd_errstr(err));
 		return (0);
 	}
-	if (len < 1) {
-		data[0] = 0;
-	}
-	if (len < 2) {
-		data[1] = 0;
+
+	if (audio_rev >= UAUDIO_VERSION_30) {
+		val = 0;
+	} else if (audio_rev >= UAUDIO_VERSION_20) {
+		switch (what) {
+		case GET_CUR:
+			val = (data[0] | (data[1] << 8));
+			break;
+		case GET_MIN:
+			val = (data[2] | (data[3] << 8));
+			break;
+		case GET_MAX:
+			val = (data[4] | (data[5] << 8));
+			break;
+		case GET_RES:
+			val = (data[6] | (data[7] << 8));
+			break;
+		default:
+			val = 0;
+			break;
+		}
+	} else {
+		val = (data[0] | (data[1] << 8));
 	}
-	val = (data[0] | (data[1] << 8));
+
+	if (what == GET_CUR || what == GET_MIN || what == GET_MAX)
+		val = uaudio_mixer_signext(mc->type, val);
 
 	DPRINTFN(3, "val=%d\n", val);
 
@@ -3088,8 +4904,6 @@ tr_setup:
 		while (mc) {
 			while (sc->sc_mixer_chan < mc->nchan) {
 
-				len = MIX_SIZE(mc->type);
-
 				chan = sc->sc_mixer_chan;
 
 				sc->sc_mixer_chan++;
@@ -3102,17 +4916,24 @@ tr_setup:
 				if (update) {
 
 					req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
-					req.bRequest = SET_CUR;
 					USETW(req.wValue, mc->wValue[chan]);
 					USETW(req.wIndex, mc->wIndex);
-					USETW(req.wLength, len);
 
-					if (len > 0) {
-						buf[0] = (mc->wData[chan] & 0xFF);
-					}
-					if (len > 1) {
-						buf[1] = (mc->wData[chan] >> 8) & 0xFF;
+					if (sc->sc_audio_rev >= UAUDIO_VERSION_30) {
+						return;
+					} else if (sc->sc_audio_rev >= UAUDIO_VERSION_20) {
+						len = 2;
+						req.bRequest = UA20_CS_CUR;
+						USETW(req.wLength, len);
+					} else {
+						len = MIX_SIZE(mc->type);
+						req.bRequest = SET_CUR;
+						USETW(req.wLength, len);
 					}
+
+					buf[0] = (mc->wData[chan] & 0xFF);
+					buf[1] = (mc->wData[chan] >> 8) & 0xFF;
+
 					pc = usbd_xfer_get_frame(xfer, 0);
 					usbd_copy_in(pc, 0, &req, sizeof(req));
 					pc = usbd_xfer_get_frame(xfer, 1);
@@ -3166,6 +4987,29 @@ uaudio_set_speed(struct usb_device *udev, uint8_t endpt, uint32_t speed)
 	return (usbd_do_request(udev, NULL, &req, data));
 }
 
+static usb_error_t
+uaudio20_set_speed(struct usb_device *udev, uint8_t iface_no,
+    uint8_t clockid, uint32_t speed)
+{
+	struct usb_device_request req;
+	uint8_t data[4];
+
+	DPRINTFN(6, "ifaceno=%d clockid=%d speed=%u\n",
+	    iface_no, clockid, speed);
+
+	req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
+	req.bRequest = UA20_CS_CUR;
+	USETW2(req.wValue, UA20_CS_SAM_FREQ_CONTROL, 0);
+	USETW2(req.wIndex, clockid, iface_no);
+	USETW(req.wLength, 4);
+	data[0] = speed;
+	data[1] = speed >> 8;
+	data[2] = speed >> 16;
+	data[3] = speed >> 24;
+
+	return (usbd_do_request(udev, NULL, &req, data));
+}
+
 static int
 uaudio_mixer_signext(uint8_t type, int val)
 {
@@ -3257,9 +5101,12 @@ uaudio_mixer_init_sub(struct uaudio_softc *sc, struct snd_mixer *m)
 {
 	DPRINTF("\n");
 
+	sc->sc_mixer_lock = mixer_get_lock(m);
+	sc->sc_mixer_dev = m;
+
 	if (usbd_transfer_setup(sc->sc_udev, &sc->sc_mixer_iface_index,
 	    sc->sc_mixer_xfer, uaudio_mixer_config, 1, sc,
-	    &sc->sc_lock)) {
+	    sc->sc_mixer_lock)) {
 		DPRINTFN(0, "could not allocate USB "
 		    "transfer for audio mixer!\n");
 		return (ENOMEM);
@@ -3280,6 +5127,8 @@ uaudio_mixer_uninit_sub(struct uaudio_softc *sc)
 
 	usbd_transfer_unsetup(sc->sc_mixer_xfer, 1);
 
+	sc->sc_mixer_lock = NULL;
+
 	return (0);
 }
 
@@ -3290,13 +5139,13 @@ uaudio_mixer_set(struct uaudio_softc *sc, unsigned type,
 	struct uaudio_mixer_node *mc;
 	int chan;
 
-	for (mc = sc->sc_mixer_root; mc;
-	    mc = mc->next) {
+	for (mc = sc->sc_mixer_root; mc != NULL; mc = mc->next) {
 
 		if (mc->ctl == type) {
 			for (chan = 0; chan < mc->nchan; chan++) {
 				uaudio_mixer_ctl_set(sc, mc, chan,
-				    (int)((chan == 0 ? left : right) * 255) / 100);
+				    (int)((chan == 0 ? left : right) *
+				    255) / 100);
 			}
 		}
 	}
@@ -3386,8 +5235,7 @@ umidi_bulk_read_callback(struct usb_xfer *xfer, usb_error_t error)
 			 */
 			sub = &chan->sub[cn];
 
-			if ((cmd_len != 0) &&
-			    (cn < chan->max_cable) &&
+			if ((cmd_len != 0) && (cn < chan->max_emb_jack) &&
 			    (sub->read_open != 0)) {
 
 				/* Send data to the application */
@@ -3623,7 +5471,7 @@ tr_setup:
 			}
 
 			chan->curr_cable++;
-			if (chan->curr_cable >= chan->max_cable)
+			if (chan->curr_cable >= chan->max_emb_jack)
 				chan->curr_cable = 0;
 
 			if (chan->curr_cable == start_cable) {
@@ -3660,7 +5508,7 @@ umidi_sub_by_fifo(struct usb_fifo *fifo)
 	struct umidi_sub_chan *sub;
 	uint32_t n;
 
-	for (n = 0; n < UMIDI_CABLES_MAX; n++) {
+	for (n = 0; n < UMIDI_EMB_JACK_MAX; n++) {
 		sub = &chan->sub[n];
 		if ((sub->fifo.fp[USB_FIFO_RX] == fifo) ||
 		    (sub->fifo.fp[USB_FIFO_TX] == fifo)) {
@@ -3746,7 +5594,6 @@ umidi_open(struct usb_fifo *fifo, int fflags)
 		}
 		/* clear stall first */
 		lockmgr(&chan->lock, LK_EXCLUSIVE);
-		usbd_xfer_set_stall(chan->xfer[UMIDI_TX_TRANSFER]);
 		chan->write_open_refcount++;
 		sub->write_open = 1;
 
@@ -3825,12 +5672,31 @@ umidi_probe(device_t dev)
 		DPRINTF("error=%s\n", usbd_errstr(error));
 		goto detach;
 	}
-	if ((chan->max_cable > UMIDI_CABLES_MAX) ||
-	    (chan->max_cable == 0)) {
-		chan->max_cable = UMIDI_CABLES_MAX;
+
+	/*
+	 * Some USB MIDI device makers couldn't resist using
+	 * wMaxPacketSize = 4 for RX and TX BULK endpoints, although
+	 * that size is an unsupported value for FULL speed BULK
+	 * endpoints. The same applies to some HIGH speed MIDI devices
+	 * which are using a wMaxPacketSize different from 512 bytes.
+	 *
+	 * Refer to section 5.8.3 in USB 2.0 PDF: Cite: "All Host
+	 * Controllers are required to have support for 8-, 16-, 32-,
+	 * and 64-byte maximum packet sizes for full-speed bulk
+	 * endpoints and 512 bytes for high-speed bulk endpoints."
+	 */
+	if (usbd_xfer_maxp_was_clamped(chan->xfer[UMIDI_TX_TRANSFER]))
+		chan->single_command = 1;
+
+	if (chan->single_command != 0)
+		device_printf(dev, "Single command MIDI quirk enabled\n");
+
+	if ((chan->max_emb_jack == 0) ||
+	    (chan->max_emb_jack > UMIDI_EMB_JACK_MAX)) {
+		chan->max_emb_jack = UMIDI_EMB_JACK_MAX;
 	}
 
-	for (n = 0; n < chan->max_cable; n++) {
+	for (n = 0; n < chan->max_emb_jack; n++) {
 
 		sub = &chan->sub[n];
 
@@ -3845,9 +5711,6 @@ umidi_probe(device_t dev)
 
 	lockmgr(&chan->lock, LK_EXCLUSIVE);
 
-	/* clear stall first */
-	usbd_xfer_set_stall(chan->xfer[UMIDI_RX_TRANSFER]);
-
 	/*
 	 * NOTE: At least one device will not work properly unless the
 	 * BULK IN pipe is open all the time. This might have to do
@@ -3871,9 +5734,8 @@ umidi_detach(device_t dev)
 	struct umidi_chan *chan = &sc->sc_midi_chan;
 	uint32_t n;
 
-	for (n = 0; n < UMIDI_CABLES_MAX; n++) {
+	for (n = 0; n < UMIDI_EMB_JACK_MAX; n++)
 		usb_fifo_detach(&chan->sub[n].fifo);
-	}
 
 	lockmgr(&chan->lock, LK_EXCLUSIVE);
 
@@ -3888,7 +5750,171 @@ umidi_detach(device_t dev)
 	return (0);
 }
 
-DRIVER_MODULE(uaudio, uhub, uaudio_driver, uaudio_devclass, NULL, NULL);
+static void
+uaudio_hid_rx_callback(struct usb_xfer *xfer, usb_error_t error)
+{
+	struct uaudio_softc *sc = usbd_xfer_softc(xfer);
+	const uint8_t *buffer = usbd_xfer_get_frame_buffer(xfer, 0);
+	struct snd_mixer *m;
+	uint8_t id;
+	int actlen;
+
+	usbd_xfer_status(xfer, &actlen, NULL, NULL, NULL);
+
+	switch (USB_GET_STATE(xfer)) {
+	case USB_ST_TRANSFERRED:
+		DPRINTF("actlen=%d\n", actlen);
+
+		if (actlen != 0 &&
+		    (sc->sc_hid.flags & UAUDIO_HID_HAS_ID)) {
+			id = *buffer;
+			buffer++;
+			actlen--;
+		} else {
+			id = 0;
+		}
+
+		m = sc->sc_mixer_dev;
+
+		if ((sc->sc_hid.flags & UAUDIO_HID_HAS_MUTE) &&
+		    (sc->sc_hid.mute_id == id) &&
+		    hid_get_data(buffer, actlen,
+		    &sc->sc_hid.mute_loc)) {
+
+			DPRINTF("Mute toggle\n");
+
+			mixer_hwvol_mute_locked(m);
+		}
+
+		if ((sc->sc_hid.flags & UAUDIO_HID_HAS_VOLUME_UP) &&
+		    (sc->sc_hid.volume_up_id == id) &&
+		    hid_get_data(buffer, actlen,
+		    &sc->sc_hid.volume_up_loc)) {
+
+			DPRINTF("Volume Up\n");
+
+			mixer_hwvol_step_locked(m, 1, 1);
+		}
+
+		if ((sc->sc_hid.flags & UAUDIO_HID_HAS_VOLUME_DOWN) &&
+		    (sc->sc_hid.volume_down_id == id) &&
+		    hid_get_data(buffer, actlen,
+		    &sc->sc_hid.volume_down_loc)) {
+
+			DPRINTF("Volume Down\n");
+
+			mixer_hwvol_step_locked(m, -1, -1);
+		}
+
+	case USB_ST_SETUP:
+tr_setup:
+		/* check if we can put more data into the FIFO */
+		usbd_xfer_set_frame_len(xfer, 0, usbd_xfer_max_len(xfer));
+		usbd_transfer_submit(xfer);
+		break;
+
+	default:			/* Error */
+
+		DPRINTF("error=%s\n", usbd_errstr(error));
+
+		if (error != USB_ERR_CANCELLED) {
+			/* try to clear stall first */
+			usbd_xfer_set_stall(xfer);
+			goto tr_setup;
+		}
+		break;
+	}
+}
+
+static int
+uaudio_hid_probe(struct uaudio_softc *sc,
+    struct usb_attach_arg *uaa)
+{
+	void *d_ptr;
+	uint32_t flags;
+	uint16_t d_len;
+	uint8_t id;
+	int error;
+
+	if (!(sc->sc_hid.flags & UAUDIO_HID_VALID))
+		return (-1);
+
+	if (sc->sc_mixer_lock == NULL)
+		return (-1);
+
+	/* Get HID descriptor */
+	error = usbd_req_get_hid_desc(uaa->device, NULL, &d_ptr,
+	    &d_len, M_TEMP, sc->sc_hid.iface_index);
+
+	if (error) {
+		DPRINTF("error reading report description\n");
+		return (-1);
+	}
+
+	/* check if there is an ID byte */
+	hid_report_size(d_ptr, d_len, hid_input, &id);
+
+	if (id != 0)
+		sc->sc_hid.flags |= UAUDIO_HID_HAS_ID;
+
+	if (hid_locate(d_ptr, d_len,
+	    HID_USAGE2(HUP_CONSUMER, 0xE9 /* Volume Increment */),
+	    hid_input, 0, &sc->sc_hid.volume_up_loc, &flags,
+	    &sc->sc_hid.volume_up_id)) {
+		if (flags & HIO_VARIABLE)
+			sc->sc_hid.flags |= UAUDIO_HID_HAS_VOLUME_UP;
+		DPRINTFN(1, "Found Volume Up key\n");
+	}
+
+	if (hid_locate(d_ptr, d_len,
+	    HID_USAGE2(HUP_CONSUMER, 0xEA /* Volume Decrement */),
+	    hid_input, 0, &sc->sc_hid.volume_down_loc, &flags,
+	    &sc->sc_hid.volume_down_id)) {
+		if (flags & HIO_VARIABLE)
+			sc->sc_hid.flags |= UAUDIO_HID_HAS_VOLUME_DOWN;
+		DPRINTFN(1, "Found Volume Down key\n");
+	}
+
+	if (hid_locate(d_ptr, d_len,
+	    HID_USAGE2(HUP_CONSUMER, 0xE2 /* Mute */),
+	    hid_input, 0, &sc->sc_hid.mute_loc, &flags,
+	    &sc->sc_hid.mute_id)) {
+		if (flags & HIO_VARIABLE)
+			sc->sc_hid.flags |= UAUDIO_HID_HAS_MUTE;
+		DPRINTFN(1, "Found Mute key\n");
+	}
+
+	kfree(d_ptr, M_TEMP);
+
+	if (!(sc->sc_hid.flags & (UAUDIO_HID_HAS_VOLUME_UP |
+	    UAUDIO_HID_HAS_VOLUME_DOWN |
+	    UAUDIO_HID_HAS_MUTE))) {
+		DPRINTFN(1, "Did not find any volume related keys\n");
+		return (-1);
+	}
+
+	/* prevent the uhid driver from attaching */
+	usbd_set_parent_iface(uaa->device, sc->sc_hid.iface_index,
+	    sc->sc_mixer_iface_index);
+
+	/* allocate USB transfers */
+	error = usbd_transfer_setup(uaa->device, &sc->sc_hid.iface_index,
+	    sc->sc_hid.xfer, uaudio_hid_config, UAUDIO_HID_N_TRANSFER,
+	    sc, sc->sc_mixer_lock);
+	if (error) {
+		DPRINTF("error=%s\n", usbd_errstr(error));
+		return (-1);
+	}
+	return (0);
+}
+
+static void
+uaudio_hid_detach(struct uaudio_softc *sc)
+{
+	usbd_transfer_unsetup(sc->sc_hid.xfer, UAUDIO_HID_N_TRANSFER);
+}
+
+DRIVER_MODULE_ORDERED(uaudio, uhub, uaudio_driver, uaudio_devclass, NULL, 0, SI_ORDER_ANY);
 MODULE_DEPEND(uaudio, usb, 1, 1, 1);
 MODULE_DEPEND(uaudio, sound, SOUND_MINVER, SOUND_PREFVER, SOUND_MAXVER);
 MODULE_VERSION(uaudio, 1);
diff --git a/sys/bus/u4b/audio/uaudio.h b/sys/bus/u4b/audio/uaudio.h
index 10c10de..44479df 100644
--- a/sys/bus/u4b/audio/uaudio.h
+++ b/sys/bus/u4b/audio/uaudio.h
@@ -1,4 +1,4 @@
-/* $FreeBSD$ */
+/* $FreeBSD: head/sys/dev/sound/usb/uaudio.h 228484 2011-12-14 00:48:20Z hselasky $ */
 
 /*-
  * Copyright (c) 2000-2002 Hiroyuki Aizu <aizu@navi.org>
